kAlert.config = {}
kAlert.config.movers = {}
kAlert.config.mainFrame = nil
kAlert.config.layoutFrame = nil
kAlert.config.active = false
kAlert.config.tLocation = {"CENTER","TOPCENTER","BOTTOMCENTER","LEFTCENTER","RIGHTCENTER"}
kAlert.config.recources = {kAlertTexts.resHealth,kAlertTexts.resMana,kAlertTexts.resEnergy,kAlertTexts.resPower,kAlertTexts.resCharge,kAlertTexts.resComboPoints}
kAlert.config.units = {kAlertTexts.unitPlayer,kAlertTexts.unitTarget,kAlertTexts.unitFocus,kAlertTexts.unitPet}
kAlert.config.evaluationTypes = {kAlertTexts.buff,kAlertTexts.ability,kAlertTexts.resource,kAlertTexts.casting}


function kAlert.config.main()

	kAlert.config.active = true
	if kAlert.config.mainFrame == nil then
		kAlert.config.buildMainFrame()
	else
		kAlert.config.mainFrame:SetVisible(true)
	end
	kAlert.config.mainFrame.btClear.Event:LeftPress()
	kAlert.config.mainFrame.frScreenObjects.fillList(kAlert.alertSet.alerts)
	kAlert.config.mainFrame.txtASNumber:SetText("Set " .. tostring(kAlertSet))
	kAlert.config.mainFrame.txtASNumber:SetWidth(kAlert.config.mainFrame.txtASNumber:GetFullWidth())
	
end

function kAlert.config.buildLayoutFrame()
	local window = UI.CreateFrame("RiftWindow", "kAlertConfigLayoutFrame", kAlert.context)
	window:SetTitle(kAlertTexts.titleLayout)
	window:SetHeight(100)
	window:SetWidth(260)
	window:SetPoint("TOPLEFT", UIParent, "TOPLEFT",UIParent:GetWidth()/2-100,UIParent:GetHeight()/2-50)
	window:SetLayer(99)
	-- Mover Box
	window.frMoveBar = kUtils.buildWindowMover("frMoveBar", window, true)

	window.btSave = kUtils.buildButton("btSave",window,35,120,kAlertTexts.btSave)
	window.btSave:SetPoint ("TOPCENTER", window, "TOPCENTER", -60, 50)

	function window.btSave.Event:LeftPress()
		for id, details in pairs(kAlert.screenObjects.object) do
			if details.name ~= nill then
				kAlert.config.movers.object[id].clearTarget()
				if kAlert.alertSet.alerts[details.name] ~= nil then
					kAlert.alertSet.alerts[details.name].imageX = details:GetLeft()
					kAlert.alertSet.alerts[details.name].imageY = details:GetTop()
				end
			end
		end
		kAlert.screenObjects.hide()
		window:SetVisible(false)
		kAlert.config.mainFrame:SetVisible(true)
	end
	
	window.btCancel = kUtils.buildButton("btCancel",window,35,120,kAlertTexts.btCancel)
	window.btCancel:SetPoint ("LEFTCENTER", window.btSave, "RIGHTCENTER")
	
	function window.btCancel.Event:LeftPress()
		for id, details in pairs(kAlert.screenObjects.object) do
			if details.name ~= nill then
				kAlert.config.movers.object[id].clearTarget()
			end
		end
		kAlert.screenObjects.hide()
		window:SetVisible(false)
		kAlert.config.mainFrame:SetVisible(true)
	end

	kAlert.config.layoutFrame = window
	
end

function kAlert.config.buildMainFrame()

	local window = UI.CreateFrame("RiftWindow", "kAlertConfigMainFrame", kAlert.context)
	window:SetTitle(kAlertTexts.addonName)
	window:SetHeight(600)
	window:SetWidth(890)
	window:SetPoint("TOPLEFT", UIParent, "TOPLEFT",UIParent:GetWidth()/2-445,UIParent:GetHeight()/2-280)

	-- Mover Box
	window.frMoveBar = kUtils.buildWindowMover("frMoveBar", window, true)

	-- Alert Set Controls
	window.btASLeft = kUtils.buildButton("btASLeft",window,25,60,"<-")
	window.btASLeft:SetPoint ("TOPLEFT", window, "TOPLEFT", 30, 65)

	function window.btASLeft.Event:LeftPress()
		if kAlertSet > 1 then
			kAlertSet = kAlertSet - 1
			window.txtASNumber:SetText("Set " .. tostring(kAlertSet))
			window.txtASNumber:SetWidth(window.txtASNumber:GetFullWidth())
			kAlert.alertSet.load()
			window.frScreenObjects.fillList(kAlert.alertSet.alerts)
		end
	end
	
	window.frASFrame = kUtils.buildFrame("frASFrame",window,25,80)
	window.frASFrame:SetPoint("BOTTOMLEFT", window.btASLeft, "BOTTOMRIGHT", 0, 0)
	
	window.txtASNumber = kUtils.buildLabel("txtASNumber", window, 15, 80, "Set " .. tostring(kAlertSet))
	window.txtASNumber:SetWidth(window.txtASNumber:GetFullWidth())
	window.txtASNumber:SetPoint("CENTER", window.frASFrame, "CENTER")

	window.btASRight = kUtils.buildButton("btASRight",window,25,60,"->")
	window.btASRight:SetPoint ("BOTTOMLEFT", window.frASFrame, "BOTTOMRIGHT", 0, 0)

	function window.btASRight.Event:LeftPress()
		if kAlertSet < 5 then
			kAlertSet = kAlertSet + 1
			window.txtASNumber:SetText("Set " .. tostring(kAlertSet))
			window.txtASNumber:SetWidth(window.txtASNumber:GetFullWidth())
			kAlert.alertSet.load()
			window.frScreenObjects.fillList(kAlert.alertSet.alerts)
		end
	end
	
	window.frScreenObjects = kUtils.buildListPane("frScreenObjects",window, 410,200,kAlert.screenObjects.max)
	window.frScreenObjects:SetPoint("TOPLEFT", window.btASLeft, "BOTTOMLEFT", 0, 5)
	window.frScreenObjects.fillList(kAlert.alertSet.alerts)
	
	function window.frScreenObjects.click(button)
	
		if window.frScreenObjects.lastSelected == window.frScreenObjects.getSelected() and window.frScreenObjects.lastSelectedTime == math.floor(Inspect.Time.Real()) then
			window.btEdit.Event:LeftPress()
		else
			window.frScreenObjects.lastSelected = window.frScreenObjects.getSelected()
		end
		
		window.frScreenObjects.lastSelectedTime = math.floor(Inspect.Time.Real())
		
	end

	window.btEdit = kUtils.buildButton("btEdit",window,35,100,kAlertTexts.btEdit)
	window.btEdit:SetPoint ("TOPLEFT", window.frScreenObjects, "BOTTOMLEFT", 0, 5)
	
	function window.btEdit.Event:LeftPress()
		window.setStatus("")
		local alertData = kAlert.alertSet.alerts[window.frScreenObjects.getSelected()]
		if alertData ~= nil then
			--dump(alertData)
			window.btClear.Event:LeftPress()
			window.ebAlertName.text:SetText(alertData.name)
			for i = 1, table.getn(kAlert.units), 1 do
				if kAlert.units[i] == alertData.unit then window.tbUnit.setSelected(i) end
			end
			window.tbAlertTypes.setSelected(alertData.type)
			if alertData.typeToggle then
				window.tbAlertToggle.setSelected(1)
				window.tbResourceToggle.setSelected(1)
			else
				window.tbAlertToggle.setSelected(2)
				window.tbResourceToggle.setSelected(2)
			end
			local tValue = tostring(alertData.itemValue)
			if tValue ~= 'nil' then
				if alertData.itemValuePercent then
					tValue = tValue .. "%"
				end
				window.ebValue.text:SetText(tValue)
			end
			if alertData.type == 3 then
				window.ebAlertItem.text:SetText("")
				window.tbResourceTypes.setSelected(alertData.itemId)
				if alertData.range then
					window.tbResourceToggle.setSelected(3)
					if alertData.rangeLow == alertData.rangeHigh then
						tValue = tostring(alertData.rangeLow)
					else
						tValue = tostring(alertData.rangeLow) .. '-' .. tostring(alertData.rangeHigh)
					end
					if alertData.itemValuePercent then
						tValue = tValue .. "%"
					end
					window.ebValue.text:SetText(tValue)
				end
			else
				window.ebAlertItem.text:SetText(alertData.itemName)
				window.tbResourceTypes.setSelected(1)
			end
			window.ckSelfCast:SetChecked(alertData.selfCast)
			if alertData.itemLength > 0 then
				window.ebBuffLength.text:SetText(tostring(alertData.itemLength))
			end
			window.ckDisableAlert:SetChecked(not alertData.active)
			window.ckCombatOnly:SetChecked(alertData.combatOnly)
			for id, itemName in pairs(kUtils.split(",",alertData.itemName)) do
				if kAlertGlobalItems[itemName] ~= nil then
					window.ebImage.setDefault(kAlertGlobalItems[itemName].icon)
				end
			end
			if alertData.imageSource ~= "Rift" then
				if string.sub(alertData.image,1,6) == "custom" then
					window.btImageBack:SetVisible(false)
					window.btImageNext:SetVisible(false)
					window.ebImage.index = 0
					window.ebCustomImage.text:SetText(string.sub(alertData.image,8))
				else
					window.btImageBack:SetVisible(true)
					window.btImageNext:SetVisible(true)
					local posStart = string.find(alertData.image,"-") + 1
					local posEnd = string.find(alertData.image,".tga") - 1
					window.ebImage.index = tonumber(string.sub(alertData.image,posStart,posEnd))
					if window.ebImage.index == 1 then
						window.btImageBack:SetVisible(false)
						window.btImageNext:SetVisible(true)
					elseif window.ebImage.index == window.ebImage.count then
						window.btImageBack:SetVisible(true)
						window.btImageNext:SetVisible(false)
					end
				end
				window.ckDefaultImage:SetChecked(false)
			else
				window.ebImage.index = 0
				window.ckDefaultImage:SetChecked(true)
			end
			window.ebImage.setImage(alertData.imageSource,alertData.image)
			window.ebImageX.text:SetText(tostring(alertData.imageX))
			window.ebImageY.text:SetText(tostring(alertData.imageY))
			window.ebImageScale.text:SetText(tostring(alertData.imageScale))
			window.ebImageOpacity.text:SetText(tostring(alertData.imageOpacity*100))
			window.ebText.text:SetText(alertData.text)
			window.ebTextOpacity.text:SetText(tostring(alertData.textOpacity*100))
			if string.sub(alertData.textFont,1,6) == "custom" then
				window.ebTextFont.text:SetText(string.sub(alertData.textFont,8))
			end
			window.ebRed.text:SetText(tostring(alertData.textRed*100))
			window.ebGreen.text:SetText(tostring(alertData.textGreen*100))
			window.ebBlue.text:SetText(tostring(alertData.textBlue*100))
			window.slRed:SetPosition(math.floor(alertData.textRed*100))
			window.slGreen:SetPosition(math.floor(alertData.textGreen*100))
			window.slBlue:SetPosition(math.floor(alertData.textBlue*100))
			window.frColor.setColor()
			window.ebTextSize.text:SetText(tostring(alertData.textSize))
			for i = 1, table.getn(kAlert.config.tLocation), 1 do
				if kAlert.config.tLocation[i] == alertData.textLocation then
					window.tbTextLocation.setSelected(i)
				end
			end
			if alertData.textInside then
				window.tbTextInside.setSelected(1)
			else
				window.tbTextInside.setSelected(2)
			end
			window.ckTimer:SetChecked(alertData.timer)
			window.ebTimerSize.text:SetText(tostring(alertData.timerSize))
			for i = 1, table.getn(kAlert.config.tLocation), 1 do
				if kAlert.config.tLocation[i] == alertData.timerLocation then
					window.tbTimerLocation.setSelected(i)
				end
			end
			if alertData.timerInside then
				window.tbTimerInside.setSelected(1)
			else
				window.tbTimerInside.setSelected(2)
			end
			window.ebTimerLength.text:SetText(tostring(alertData.timerLength-1))
			window.frScreenObjects.clearSelected()
			window.ebAlertName.text:SetKeyFocus(true)
			window.setStatus(kAlertTexts.statLoaded)
		end
	end
	
	window.btDelete = kUtils.buildButton("btDelete",window,35,100,kAlertTexts.btDelete)
	window.btDelete:SetPoint ("TOPLEFT", window.btEdit, "TOPRIGHT")
	
	function window.btDelete.Event:LeftPress()
		window.setStatus("")
		local alertName = window.frScreenObjects.getSelected()
		if kAlert.alertSet.alerts[alertName] ~= nil then
			kAlert.alertSet.delete(alertName)
			window.frScreenObjects.fillList(kAlert.alertSet.alerts)
			window.btClear.Event:LeftPress()
		end
		kAlert.screenObjects.refresh()
	end
	
	window.btEditLayout = kUtils.buildButton("btEditLayout",window,35,100,kAlertTexts.btEditLayout)
	window.btEditLayout:SetPoint("TOPLEFT", window.btEdit, "BOTTOMLEFT", 50, 0)
	
	function window.btEditLayout.Event:LeftPress()
		window:SetVisible(false)
		kAlert.config.mainFrame.btClear.Event:LeftPress()
		kAlert.config.movers.init()
		for id, details in pairs(kAlert.screenObjects.object) do
			if details.name ~= nill then
				details:SetVisible(true)
				kAlert.config.movers.object[id].setTarget(details)
			end
		end
		if kAlert.config.layoutFrame == nil then
			kAlert.config.buildLayoutFrame()
		else
			kAlert.config.layoutFrame:SetVisible(true)
		end
	end

	-- Alert Info Controls
	window.ebAlertName = kUtils.buildEditBox("ebAlertName",window,20,200,kAlertTexts.ebAlertName .. ":")
	window.ebAlertName:SetPoint("TOPLEFT", window.btASRight, "TOPRIGHT", 10, 0)

	window.ckDisableAlert = kUtils.buildCheckBox("ckDisableAlert",window,20,180,kAlertTexts.ckDisableAlert)
	window.ckDisableAlert:SetPoint ("TOPLEFT", window.ebAlertName, "TOPRIGHT", 10, 0)
	
	-- Trigger Controls
	window.tbAlertTypes = kUtils.buildToggleBox("tbAlertTypes",window, 20, 200, kAlert.config.evaluationTypes)
	window.tbAlertTypes:SetPoint("TOPLEFT", window.ebAlertName, "BOTTOMLEFT", 0, 5)
	function window.tbAlertTypes.change()
		local checkType = window.tbAlertTypes.getSelected()
		if checkType == 1 then
			window.ebAlertItem:SetVisible(true)
			window.ckTimer:SetVisible(true)
			window.lblResourceTypes:SetVisible(false)
			window.tbUnit:SetVisible(true)
			window.ebAlertItem.label:SetText(kAlertTexts.buff .. ":")
			window.ebAlertItem:SetPoint("TOPLEFT", window.tbUnit, "BOTTOMLEFT", 0, 5)
			window.tbAlertToggle.setOptions({kAlertTexts.tbAlertToggleActive,kAlertTexts.tbAlertToggleMissing})
			window.ebValue:SetPoint("TOPLEFT", window.ebAlertItem, "BOTTOMLEFT", 0, 5)
			window.ebValue.label:SetText(kAlertTexts.ebStacks .. ":")
			window.ebValue:SetVisible(true)
			window.ckSelfCast:SetVisible(true)
			window.tbAlertToggle:SetVisible(true)
			window.tbResourceToggle:SetVisible(false)
			window.ckCombatOnly:SetPoint("TOPLEFT", window.tbAlertToggle, "BOTTOMLEFT", 0, 5)
		elseif checkType == 2 then
			window.ebAlertItem:SetVisible(true)
			window.ckTimer:SetVisible(true)
			window.lblResourceTypes:SetVisible(false)
			window.tbUnit.setSelected(1)
			window.tbUnit:SetVisible(false)
			window.ebAlertItem.label:SetText(kAlertTexts.ability .. ":")
			window.ebAlertItem:SetPoint("TOPLEFT", window.tbUnit, "TOPLEFT")
			window.tbAlertToggle.setOptions({kAlertTexts.tbAlertToggleReady,kAlertTexts.tbAlertToggleCooldown})
			window.ebValue:SetVisible(false)
			window.ckSelfCast:SetVisible(false)
			window.tbAlertToggle:SetVisible(true)
			window.tbResourceToggle:SetVisible(false)
			window.ckCombatOnly:SetPoint("TOPLEFT", window.tbAlertToggle, "BOTTOMLEFT", 0, 5)
		elseif checkType == 3 then
			window.ebAlertItem:SetVisible(false)
			window.ckTimer:SetVisible(false)
			window.lblResourceTypes:SetVisible(true)
			window.tbUnit:SetVisible(true)
			window.ebAlertItem:SetPoint("TOPLEFT", window.tbUnit, "BOTTOMLEFT", 0, 5)
			window.tbAlertToggle:SetVisible(false)
			window.ckTimer:SetChecked(false)
			window.ebValue:SetPoint("TOPLEFT", window.tbResourceTypes, "BOTTOMLEFT", 0, 5)
			window.ebValue.label:SetText(kAlertTexts.ebValue .. ":")
			window.ebValue:SetVisible(true)
			window.ckSelfCast:SetVisible(false)
			window.tbResourceToggle:SetVisible(true)
			window.ckCombatOnly:SetPoint("TOPLEFT", window.tbResourceToggle, "BOTTOMLEFT", 0, 5)
		elseif checkType == 4 then
			window.ebAlertItem:SetVisible(true)
			window.ckTimer:SetVisible(false)
			window.lblResourceTypes:SetVisible(false)
			window.tbUnit:SetVisible(true)
			window.ebAlertItem.label:SetText(kAlertTexts.ability .. ":")
			window.ebAlertItem:SetPoint("TOPLEFT", window.tbUnit, "BOTTOMLEFT", 0, 5)
			window.ckTimer:SetChecked(false)
			window.ebValue:SetVisible(false)
			window.ckSelfCast:SetVisible(false)
			window.tbAlertToggle:SetVisible(false)
			window.tbResourceToggle:SetVisible(false)
			window.ckCombatOnly:SetPoint("TOPLEFT", window.tbAlertTypes, "BOTTOMLEFT", 0, 5)
		end
		window.tbAlertToggle.change()
	end

	window.tbAlertToggle = kUtils.buildToggleBox("tbAlertToggle",window, 20, 100, {kAlertTexts.tbAlertToggleAbove,kAlertTexts.tbAlertToggleBelow},2)
	window.tbAlertToggle:SetPoint("TOPLEFT", window.tbAlertTypes, "BOTTOMLEFT", 0, 5)
	function window.tbAlertToggle.change()
		local checkType = window.tbAlertTypes.getSelected()
		local toggleType = window.tbAlertToggle.getSelected()
		if checkType == toggleType then
			window.ckTimer.label:SetText(kAlertTexts.ckTimerTimer)
			window.ebTimerLength:SetVisible(false)
		else
			window.ckTimer.label:SetText(kAlertTexts.ckTimerWarning)
			window.ebTimerLength:SetVisible(true)
		end
	end

	window.tbResourceToggle = kUtils.buildToggleBox("tbResourceToggle",window, 20, 100, {kAlertTexts.tbAlertToggleAbove,kAlertTexts.tbAlertToggleBelow,kAlertTexts.tbAlertToggleRange},2)
	window.tbResourceToggle:SetPoint("TOPLEFT", window.tbAlertTypes, "BOTTOMLEFT", 0, 5)
	window.tbResourceToggle:SetVisible(false)

	
	window.ckCombatOnly = kUtils.buildCheckBox("ckCombatOnly",window, 20, 200, kAlertTexts.ckCombatOnly)
	window.ckCombatOnly:SetPoint("TOPLEFT", window.tbAlertToggle, "BOTTOMLEFT", 0, 5)
	
	window.tbUnit = kUtils.buildToggleBox("tbUnit",window, 20, 100, kAlert.config.units,2)
	window.tbUnit:SetPoint("TOPLEFT", window.ckCombatOnly, "BOTTOMLEFT", 0, 5)

	window.ebAlertItem = kUtils.buildEditBox("ebAlertItem",window,20,200,kAlertTexts.ability .. ":")
	window.ebAlertItem:SetPoint("TOPLEFT", window.tbUnit, "BOTTOMLEFT", 0, 5)
	function window.ebAlertItem.text.Event:KeyFocusLoss()
		window.frItemDrop:SetVisible(false)
	end
	function window.ebAlertItem.text.Event:KeyUp()
	
		local itemName = window.ebAlertItem.text:GetText()
		if itemName ~= nil and string.len(itemName) > 0 then
			if window.ebAlertItem.label:GetText() == kAlertTexts.buff .. ":" then
				local pos = string.find(string.reverse(itemName),",")
				if pos ~= nil then itemName = string.sub(itemName,2+string.len(itemName)-pos) end
			end
			if string.len(itemName) > 0 then
				window.frItemDrop:SetVisible((window.frItemDrop.fillListSubSet(kAlertGlobalItems,itemName) > 0))
			end
		else
			window.frItemDrop:SetVisible(false)
		end
		if kAlertGlobalItems[itemName] ~= nil then
			window.ebImage.setDefault(kAlertGlobalItems[itemName].icon)
		end

	end
	window.frItemDrop = kUtils.buildListPane("frItemDrop",window, 200,200,10)
	window.frItemDrop:SetPoint("TOPRIGHT", window.ebAlertItem.text, "BOTTOMRIGHT", 0, 0)
	window.frItemDrop:SetBackgroundColor(0, 0, 0, 1)
	window.frItemDrop:SetLayer(2)
	window.frItemDrop:SetVisible(false)
	
	function window.frItemDrop.click(button)
	
		if window.frItemDrop.lastSelected == window.frItemDrop.getSelected() and window.frItemDrop.lastSelectedTime == math.floor(Inspect.Time.Real()) then
			local itemPre = ""
			if window.ebAlertItem.label:GetText() == kAlertTexts.buff .. ":" then
				local itemName = window.ebAlertItem.text:GetText()
				if itemName ~= nil and string.len(itemName) > 0 then
					local pos = string.find(string.reverse(itemName),",")
					if pos ~= nil then itemPre = string.sub(itemName,1,string.len(itemName)-pos) .. "," end
				end
			end
			window.ebAlertItem.text:SetText(itemPre .. window.frItemDrop.getSelected())
			window.ebAlertItem.text.Event:KeyUp()
			window.ebAlertItem.text:SetCursor(string.len(window.ebAlertItem.text:GetText()))
			window.frItemDrop:SetVisible(false)
		else
			window.frItemDrop.lastSelected = window.frItemDrop.getSelected()
		end
		
		window.frItemDrop.lastSelectedTime = math.floor(Inspect.Time.Real())
		
	end

	window.lblResourceTypes = kUtils.buildLabel("lblResourceTypes", window, 15, 200, kAlertTexts.lblResourceTypes .. ":")
	window.lblResourceTypes:SetPoint("TOPLEFT", window.ebAlertItem, "TOPLEFT")

	window.tbResourceTypes = kUtils.buildToggleBox("tbResourceTypes",window.lblResourceTypes, 20, 200, kAlert.config.recources)
	window.tbResourceTypes:SetPoint("TOPLEFT", window.lblResourceTypes, "BOTTOMLEFT")

	window.ebValue = kUtils.buildEditBox("ebValue",window,20,200,kAlertTexts.ebStacks .. ":")
	window.ebValue:SetPoint("TOPLEFT", window.tbResourceTypes, "BOTTOMLEFT", 0, 5)
	
	window.ckSelfCast = kUtils.buildCheckBox("ckSelfCast",window, 20, 200, kAlertTexts.ckSelfCast)
	window.ckSelfCast:SetPoint("TOPLEFT", window.ebValue, "BOTTOMLEFT", 0, 5)

	window.ebBuffLength = kUtils.buildEditBox("ebBuffLength",window.ckSelfCast,20,200,kAlertTexts.ebTimerLength .. ":")
	window.ebBuffLength:SetPoint("TOPLEFT", window.ckSelfCast, "BOTTOMLEFT", 0, 5)
	window.ebBuffLength.text:SetText("")
	
	-- Display Controls
	-- Display Image
	window.ebImage = kUtils.buildImageBox("ebImage", window, 200, 200, "kAlert", "images\\Aura-1.tga")
	window.ebImage:SetPoint("TOPLEFT", window.tbAlertTypes, "TOPRIGHT", 10, 0)
	window.ebImage:SetLayer(-1)
	window.ebImage.count = 75
	function window.ebImage.clear()
		window.ebImage.index = 1
		window.ebImage.defSorce = nil
		window.ebImage.defImage = nil
		window.ckDefaultImage:SetVisible(false)
		window.ckDefaultImage:SetChecked(false)
		window.btImageBack:SetVisible(false)
		window.ebImage.setImage("kAlert", "images\\Aura-1.tga")
	end
	
	function window.ebImage.setDefault(image)
		window.ebImage.defSorce = "Rift"
		window.ebImage.defImage = image
		if window.ebImage.index <= 1 then
			window.ebImage.index = 0
			window.ebImage.setImage("Rift", image)
			window.ckDefaultImage:SetChecked(true)
		end
		window.ckDefaultImage:SetVisible(true)
	end

	window.ckDefaultImage = kUtils.buildCheckBox("ckDefaultImage",window, 20, 195, kAlertTexts.ckUseDefaultImage)
	window.ckDefaultImage:SetPoint("TOPLEFT", window.ebImage, "TOPLEFT", 5, 2)
	window.ckDefaultImage.label:SetBackgroundColor(0, 0, 0, 0.5)
	window.ckDefaultImage:SetVisible(false)

	function window.ckDefaultImage.Event:CheckboxChange()
		if window.ckDefaultImage:GetChecked() then
			window.btImageBack:SetVisible(false)
			window.btImageNext:SetVisible(false)
			window.ebImage.index = 0
			window.ebImage.setImage(window.ebImage.defSorce, window.ebImage.defImage)
		else
			window.btImageBack:SetVisible(false)
			window.btImageNext:SetVisible(true)
			window.ebImage.index = 1
			window.ebImage.setImage("kAlert", "images\\Aura-1.tga")
		end
	end
	
	window.btImageBack = kUtils.buildLabel("btImageBack",window,35,30,"<")
	window.btImageBack:SetBackgroundColor(0, 0, 0, 0.5)
	window.btImageBack:SetPoint ("LEFTCENTER", window.ebImage, "LEFTCENTER")
	function window.btImageBack.Event:LeftClick()
	
		if window.ebImage.index > 1 then
			window.ebImage.index = window.ebImage.index - 1
			window.ebImage.setImage("kAlert", "images\\Aura-" .. tostring(window.ebImage.index) .. ".tga")
			if window.ebImage.index == 1 and window.ebImage.index < window.ebImage.count then
				window.btImageBack:SetVisible(false)
			end
			window.btImageNext:SetVisible(true)
		end
		
			
	end

	window.btImageNext = kUtils.buildLabel("btImageNext",window,35,30,">")
	window.btImageNext:SetBackgroundColor(0, 0, 0, 0.5)
	window.btImageNext:SetPoint ("RIGHTCENTER", window.ebImage, "RIGHTCENTER")
	
	function window.btImageNext.Event:LeftClick()
	
		if window.ebImage.index < window.ebImage.count then
			window.ebImage.index = window.ebImage.index + 1
			window.ebImage.setImage("kAlert", "images\\Aura-" .. tostring(window.ebImage.index) .. ".tga")
			if window.ebImage.index == window.ebImage.count and window.ebImage.index > 1 then
				window.btImageNext:SetVisible(false)
			end
			window.btImageBack:SetVisible(true)
		end
		
			
	end
	
	window.ebCustomImage = kUtils.buildEditBox("ebCustomImage",window,20,200,kAlertTexts.ebCustomImage .. ":")
	window.ebCustomImage:SetPoint("TOPLEFT", window.ebImage, "BOTTOMLEFT", 0, 5)
	function window.ebCustomImage.text.Event:KeyUp()
		
		if string.len(window.ebCustomImage.text:GetText()) > 0 then
			window.btImageBack:SetVisible(false)
			window.btImageNext:SetVisible(false)
			window.ebImage.setImage("kAlert", "custom\\" .. window.ebCustomImage.text:GetText())
		else
			window.btImageBack:SetVisible(true)
			window.btImageNext:SetVisible(true)
			if window.ebImage.index == 0 then
				if window.ebImage.defSorce ~= nil then
					window.ebImage.setImage(window.ebImage.defSorce, window.ebImage.defImage)
				else
					window.ebImage.index = 1
					window.ebImage.setImage("kAlert", "images\\Aura-1.tga")
				end
			else
				window.ebImage.setImage("kAlert", "images\\Aura-" .. tostring(window.ebImage.index) .. ".tga")
			end
		end

	end	
	
	window.ebImageX = kUtils.buildEditBox("ebImageX",window,20,95,kAlertTexts.ebImageX .. ":")
	window.ebImageX:SetPoint("TOPLEFT", window.ebCustomImage, "BOTTOMLEFT", 0, 5)
	
	window.ebImageY = kUtils.buildEditBox("ebImageY",window,20,95,kAlertTexts.ebImageY .. ":")
	window.ebImageY:SetPoint("TOPLEFT", window.ebImageX, "TOPRIGHT", 10, 0)

	window.ebImageScale = kUtils.buildEditBox("ebImageScale",window,20,95,kAlertTexts.ebImageScale .. ":")
	window.ebImageScale:SetPoint("TOPLEFT", window.ebImageX, "BOTTOMLEFT", 0, 5)

	window.ebImageOpacity = kUtils.buildEditBox("ebImageOpacity",window,20,95,kAlertTexts.ebOpacity .. ":")
	window.ebImageOpacity:SetPoint("TOPLEFT", window.ebImageScale, "TOPRIGHT", 10, 0)
	function window.ebImageOpacity.text.Event:KeyUp()
		local opacity = tonumber(window.ebImageOpacity.text:GetText())
		if opacity ~= nil then
			opacity = math.floor(opacity)
			opacity = math.max(0,opacity)
			opacity = math.min(100,opacity)
			window.ebImageOpacity.text:SetText(tostring(opacity))
		end
	end

	-- Display Text
	window.ebText = kUtils.buildEditBox("ebText",window,20,200,kAlertTexts.ebText .. ":")
	window.ebText:SetPoint("TOPLEFT", window.ebImage, "TOPRIGHT", 10, 0)

	window.ebTextOpacity = kUtils.buildEditBox("ebTextOpacity",window.ebText,20,90,kAlertTexts.ebOpacity .. ":")
	window.ebTextOpacity:SetPoint("TOPLEFT", window.ebText, "BOTTOMLEFT", 0, 5)
	function window.ebTextOpacity.text.Event:KeyUp()
		local opacity = tonumber(window.ebTextOpacity.text:GetText())
		if opacity ~= nil then
			opacity = math.floor(opacity)
			opacity = math.max(0,opacity)
			opacity = math.min(100,opacity)
			window.ebTextOpacity.text:SetText(tostring(opacity))
		end
	end

	window.ebTextSize = kUtils.buildEditBox("ebTextSize",window.ebText,20,90,kAlertTexts.ebSize .. ":")
	window.ebTextSize:SetPoint("TOPLEFT", window.ebTextOpacity, "BOTTOMLEFT", 0, 5)
	window.ebTextSize.text:SetText("30")

	window.tbTextInside = kUtils.buildToggleBox("tbTextInside",window.ebTextSize, 20, 90, {kAlertTexts.tbInsideInside,kAlertTexts.tbInsideOutside})
	window.tbTextInside:SetPoint("TOPLEFT", window.ebTextSize, "BOTTOMLEFT", 0, 5)

	window.tbTextLocation = kUtils.buildToggleBox("tbTextLocation",window.ebTextSize, 20, 100, {kAlertTexts.tbLocationCenter,kAlertTexts.tbLocationTop,kAlertTexts.tbLocationBottom,kAlertTexts.tbLocationLeft,kAlertTexts.tbLocationRight})
	window.tbTextLocation:SetPoint("TOPLEFT", window.ebTextOpacity, "TOPRIGHT", 10, 0)

	window.ebTextFont = kUtils.buildEditBox("ebTextFont",window.ebText, 20, 200, kAlertTexts.ebTextFont .. ":")
	window.ebTextFont:SetPoint("TOPLEFT", window.tbTextInside, "BOTTOMLEFT", 0, 15)
	
	-- Display Color
	window.txtColor = kUtils.buildLabel("txtColor", window,15,50,kAlertTexts.lblColor .. ":")
	window.txtColor:SetPoint("TOPLEFT", window.ebTextFont, "BOTTOMLEFT", 0, 5)

	window.frColor = kUtils.buildFrame("frColor", window, 20, 140)
	window.frColor:SetPoint("TOPLEFT", window.txtColor, "TOPRIGHT", 10, 0)
	function window.frColor.setColor()
		local red = tonumber(window.ebRed.text:GetText())
		if red ~= nil then
			red = math.floor(red)
			red = math.max(0,red)
			red = math.min(100,red)
			window.ebRed.text:SetText(tostring(red))
		end
		local green = tonumber(window.ebGreen.text:GetText())
		if green ~= nil then
			green = math.floor(green)
			green = math.max(0,green)
			green = math.min(100,green)
			window.ebGreen.text:SetText(tostring(green))
		end
		local blue = tonumber(window.ebBlue.text:GetText())
		if blue ~= nil then
			blue = math.floor(blue)
			blue = math.max(0,blue)
			blue = math.min(100,blue)
			window.ebBlue.text:SetText(tostring(blue))
		end
		if red ~= nil and green ~= nil and blue ~= nil then
			window.frColor:SetBackgroundColor(red/100,green/100,blue/100,1)
		end
	end

	window.ebRed = kUtils.buildEditBox("ebRed",window,20,50,kAlertTexts.ebRed .. ":")
	window.ebRed.text:SetText("100")
	window.ebRed:SetPoint("TOPLEFT", window.txtColor, "BOTTOMLEFT", 0, 5)
	function window.ebRed.text.Event:KeyUp()
		window.frColor.setColor()
		window.slRed:SetPosition(tonumber(window.ebRed.text:GetText()))
	end
	
	window.slRed = kUtils.buildSlider("slRed",window.ebRed,20,140,0,100)
	window.slRed:SetPoint("CENTERLEFT", window.ebRed, "CENTERRIGHT", 10, 5)
	function window.slRed.Event:MouseMove()
		window.slRed:SetPosition(tonumber(window.ebRed.text:GetText()))
	end
	function window.slRed.Event:SliderChange()
		window.ebRed.text:SetText(tostring(window.slRed:GetPosition()))
		window.frColor.setColor()
	end

	window.ebGreen = kUtils.buildEditBox("ebGreen",window,20,50,kAlertTexts.ebGreen .. ":")
	window.ebGreen.text:SetText("100")
	window.ebGreen:SetPoint("TOPLEFT", window.ebRed, "BOTTOMLEFT", 0, 5)
	function window.ebGreen.text.Event:KeyUp()
		window.frColor.setColor()
	end
	
	window.slGreen = kUtils.buildSlider("slGreen",window.ebGreen,20,140,0,100)
	window.slGreen:SetPoint("CENTERLEFT", window.ebGreen, "CENTERRIGHT", 10, 5)
	function window.slGreen.Event:MouseMove()
		window.slGreen:SetPosition(tonumber(window.ebGreen.text:GetText()))
	end
	function window.slGreen.Event:SliderChange()
		window.ebGreen.text:SetText(tostring(window.slGreen:GetPosition()))
		window.frColor.setColor()
	end

	window.ebBlue = kUtils.buildEditBox("ebBlue",window,20,50,kAlertTexts.ebBlue .. ":")
	window.ebBlue.text:SetText("100")
	window.ebBlue:SetPoint("TOPLEFT", window.ebGreen, "BOTTOMLEFT", 0, 5)
	function window.ebBlue.text.Event:KeyUp()
		window.frColor.setColor()
	end
	
	window.slBlue = kUtils.buildSlider("slBlue",window.ebBlue,20,140,0,100)
	window.slBlue:SetPoint("CENTERLEFT", window.ebBlue, "CENTERRIGHT", 10, 5)
	function window.slBlue.Event:MouseMove()
		window.slBlue:SetPosition(tonumber(window.ebBlue.text:GetText()))
	end
	function window.slBlue.Event:SliderChange()
		window.ebBlue.text:SetText(tostring(window.slBlue:GetPosition()))
		window.frColor.setColor()
	end
	
	window.frColor.setColor()
	
	-- Display Timer
	window.ckTimer = kUtils.buildCheckBox("ckTimer",window.ebAlertItem, 20, 90, kAlertTexts.ckTimerTimer)
	window.ckTimer:SetPoint("TOPLEFT", window.ebBlue, "BOTTOMLEFT", 0, 10)
	
	function window.ckTimer.Event:CheckboxChange()
		window.ebTimerSize:SetVisible(window.ckTimer:GetChecked())
	end

	window.ebTimerSize = kUtils.buildEditBox("ebTimerSize",window.ebAlertItem,20,90,kAlertTexts.ebSize .. ":")
	window.ebTimerSize:SetPoint("TOPLEFT", window.ckTimer, "BOTTOMLEFT", 0, 5)
	window.ebTimerSize.text:SetText("30")
	window.ebTimerSize:SetVisible(false)

	window.tbTimerInside = kUtils.buildToggleBox("tbTimerInside",window.ebTimerSize, 20, 90, {kAlertTexts.tbInsideInside,kAlertTexts.tbInsideOutside})
	window.tbTimerInside:SetPoint("TOPLEFT", window.ebTimerSize, "BOTTOMLEFT", 0, 5)

	window.tbTimerLocation = kUtils.buildToggleBox("tbTimerLocation",window.ebTimerSize, 20, 100, {kAlertTexts.tbLocationCenter,kAlertTexts.tbLocationTop,kAlertTexts.tbLocationBottom,kAlertTexts.tbLocationLeft,kAlertTexts.tbLocationRight})
	window.tbTimerLocation:SetPoint("TOPLEFT", window.ckTimer.label, "TOPRIGHT", 10, 0)

	window.ebTimerLength = kUtils.buildEditBox("ebTimerLength",window.ebTimerSize,20,90,kAlertTexts.ebTimerLength .. ":")
	window.ebTimerLength:SetPoint("TOPLEFT", window.tbTimerInside, "BOTTOMLEFT", 0, 5)
	window.ebTimerLength.text:SetText("5")
	
	-- Display Base
	window.btSave = kUtils.buildButton("btSave",window,35,100,kAlertTexts.btSave)
	window.btSave:SetPoint ("BOTTOMLEFT", window.frScreenObjects, "BOTTOMRIGHT", 440, 10)

	function window.btSave.Event:LeftPress()
		window.setStatus("")
		
		local alertData = {}
		alertData.name = window.ebAlertName.text:GetText()
		alertData.unit = kAlert.units[window.tbUnit.getSelected()]
		local tValue = window.ebValue.text:GetText()
		alertData.itemValuePercent = (string.sub(tValue,string.len(tValue)) == "%")
		if alertData.itemValuePercent then
			tValue = string.sub(tValue,0,string.len(tValue)-1)
		end
		alertData.itemValue = tonumber(string.match(tValue,"(%d+)"))
		alertData.type = window.tbAlertTypes.getSelected()
		if alertData.type == 3 then
			alertData.typeToggle = (window.tbResourceToggle.getSelected() == 1)
			alertData.range = (window.tbResourceToggle.getSelected() == 3)
			if alertData.range then
				if string.find(tValue,"-") then
					local rangeLow, rangeHigh = string.match(tValue,"(%d+)-(%d+)")
					alertData.rangeLow = tonumber(rangeLow)
					alertData.rangeHigh = tonumber(rangeHigh)
				else
					alertData.rangeLow = tonumber(tValue)
					alertData.rangeHigh = tonumber(tValue)
				end
			end
		else
			alertData.typeToggle = (window.tbAlertToggle.getSelected() == 1)
		end
		if alertData.itemValue == nil then alertData.itemValue = 1 end
		if alertData.rangeLow == nil then alertData.rangeLow = 0 end
		if alertData.rangeHigh == nil then alertData.rangeHigh = 0 end
		alertData.itemId = nil
		alertData.itemName = window.ebAlertItem.text:GetText()
		alertData.selfCast = window.ckSelfCast:GetChecked()
		if tonumber(window.ebBuffLength.text:GetText()) then
			alertData.itemLength = tonumber(window.ebBuffLength.text:GetText())
		else
			alertData.itemLength = 0
		end
		alertData.active = not window.ckDisableAlert:GetChecked()
		alertData.combatOnly = window.ckCombatOnly:GetChecked()
		alertData.image = window.ebImage.image
		alertData.imageSource = window.ebImage.source
		alertData.imageX = tonumber(window.ebImageX.text:GetText())
		alertData.imageY = tonumber(window.ebImageY.text:GetText())
		alertData.imageScale = tonumber(window.ebImageScale.text:GetText())
		alertData.imageWidth = window.ebImage:GetTextureWidth() * alertData.imageScale
		alertData.imageHeight = window.ebImage:GetTextureHeight() * alertData.imageScale
		alertData.imageOpacity = tonumber(window.ebImageOpacity.text:GetText())/100
		alertData.text = window.ebText.text:GetText()
		alertData.textOpacity = tonumber(window.ebTextOpacity.text:GetText())/100
		if string.len(window.ebTextFont.text:GetText()) > 0 then
			alertData.textFont = "custom\\" .. window.ebTextFont.text:GetText()
		else
			alertData.textFont = ""
		end
		alertData.textRed = tonumber(window.ebRed.text:GetText())/100
		alertData.textGreen = tonumber(window.ebGreen.text:GetText())/100
		alertData.textBlue = tonumber(window.ebBlue.text:GetText())/100
		alertData.textSize = tonumber(window.ebTextSize.text:GetText())
		alertData.textLocation = kAlert.config.tLocation[window.tbTextLocation.getSelected()]
		alertData.textInside = (window.tbTextInside.getSelected() == 1)
		alertData.timer = window.ckTimer:GetChecked()
		alertData.timerLength = tonumber(window.ebTimerLength.text:GetText())+1
		alertData.timerSize = tonumber(window.ebTimerSize.text:GetText())
		alertData.timerLocation = kAlert.config.tLocation[window.tbTimerLocation.getSelected()]
		alertData.timerInside = (window.tbTimerInside.getSelected() == 1)
		alertData.sound = false
		alertData.set = kAlertSet
		
		local alertAddStatus = kAlertTexts.statAlertNameMissing
		local addAlert = false
		if not window.frScreenObjects.full() then
			if string.len(alertData.name) > 0 then
				if window.tbAlertTypes.getSelected() == 4 then
					addAlert = true
				elseif window.tbAlertTypes.getSelected() == 3 then
					alertData.itemId = window.tbResourceTypes.getSelected()
					alertData.itemName = kAlert.config.recources[alertData.itemId]
					addAlert = true
				elseif window.tbAlertTypes.getSelected() == 1 then
					alertAddStatus = kAlertTexts.statItemNotFound
					for id, itemName in pairs(kUtils.split(",",alertData.itemName)) do
						local itemDetails = kAlertGlobalItems[itemName]
						if itemDetails ~= nil then
							if itemDetails.ability ~= nil then
								alertData.itemId = itemDetails.ability
							else
								alertData.itemId = "none"
							end
							addAlert = true
						end
					end
				else
					alertAddStatus = kAlertTexts.statItemNotFound
					local itemDetails = kAlertGlobalItems[alertData.itemName]
					if itemDetails ~= nil then
						if itemDetails.ability ~= nil then
							alertData.itemId = itemDetails.ability
						else
							alertData.itemId = "none"
						end
						addAlert = true
					end
				end
				if addAlert then
					if kAlert.alertSet.alerts[alertData.name] == nil then
						alertAddStatus = kAlertTexts.statAlertAdded
					else
						alertAddStatus = kAlertTexts.statAlertUpdated
					end
					kAlert.alertSet.add(alertData)
					kAlert.screenObjects.refresh()
					window.btClear.Event:LeftPress()
				end
			end
		end
		--dump(alertData)
		window.frScreenObjects.fillList(kAlert.alertSet.alerts)
		kAlert.screenObjects.hide()
		window.setStatus(alertAddStatus)
	end

	window.btClear = kUtils.buildButton("btClear",window,35,100,kAlertTexts.btClear)
	window.btClear:SetPoint ("TOPLEFT", window.btSave, "TOPRIGHT")
	
	function window.btClear.Event:LeftPress()
		window.setStatus("")
		window.ebAlertName.text:SetText("")
		window.tbUnit.setSelected(1)
		window.tbAlertTypes.setSelected(1)
		window.tbAlertToggle.setSelected(1)
		window.tbResourceToggle.setSelected(1)
		window.tbResourceTypes.setSelected(1)
		window.ebAlertItem.text:SetText("")
		window.ebValue.text:SetText("")
		window.ckSelfCast:SetChecked(false)
		window.ebBuffLength.text:SetText("")
		window.ebImage.clear()
		window.ebCustomImage.text:SetText("")
		window.ebImageX.text:SetText("0")
		window.ebImageY.text:SetText("0")
		window.ebImageScale.text:SetText("1")
		window.ebImageOpacity.text:SetText("100")
		window.ebText.text:SetText("")
		window.ebTextOpacity.text:SetText("100")
		window.ebTextFont.text:SetText("")
		window.slRed:SetPosition(100)
		window.slGreen:SetPosition(100)
		window.slBlue:SetPosition(100)
		window.ebRed.text:SetText("100")
		window.ebGreen.text:SetText("100")
		window.ebBlue.text:SetText("100")
		window.frColor.setColor()
		window.ebTextSize.text:SetText("30")
		window.tbTextLocation.setSelected(1)
		window.tbTextInside.setSelected(1)
		window.ckTimer:SetChecked(false)
		window.ebTimerSize.text:SetText("30")
		window.tbTimerLocation.setSelected(1)
		window.tbTimerInside.setSelected(1)
		window.ebTimerLength.text:SetText("5")
		window.tbAlertTypes.change()
		window.frScreenObjects.clearSelected()
		window.ckDisableAlert:SetChecked(false)
		window.ckCombatOnly:SetChecked(false)
		window.ebAlertName.text:SetKeyFocus(true)
	end
	
	-- System Elements
	window.btClose = kUtils.buildButton("btClose",window,35,100,kAlertTexts.btClose)
	window.btClose:SetPoint ("TOPLEFT", window.btEditLayout, "TOPRIGHT", 590, 0)
	
	function window.btClose.Event:LeftPress()
		window.setStatus("")
		window:SetVisible(false)
		kAlert.changeHandler.changeOccured = true
		window.btClear.Event:LeftPress()
		kAlert.config.active = false
		kAlert.screenObjects.refresh()
		window.ebAlertName.text:SetKeyFocus(false)
	end

	window.ckScanBuffs = kUtils.buildCheckBox("ckScanBuffs",window,20,180,kAlertTexts.ckScanBuffs,true)
	window.ckScanBuffs:SetPoint ("TOPRIGHT", window.btClose, "TOPLEFT", -10, 10)
	
	function window.ckScanBuffs.Event:CheckboxChange()
		kAlert.systemScanner.scan()
		kAlert.systemScanner.activeScanning = window.ckScanBuffs:GetChecked()
	end

	-- Satus Output
	window.txtStatus = kUtils.buildLabel("txtStatus", window, 15, 410, "")
	window.txtStatus:SetPoint("TOPLEFT", window.btDelete, "TOPRIGHT", 10, 5)

	function window.setStatus(message)
		window.txtStatus:SetText(message)
		--if string.len(message) > 0 then print(message) end
	end

	window:SetVisible(true)

	kAlert.config.mainFrame = window
	
end

function kAlert.config.movers.init()

	if kAlert.config.movers.object == nil then
		kAlert.config.movers.object = {}
		for i = 1, kAlert.screenObjects.max, 1 do
			kAlert.config.movers.object[i] = kAlert.config.movers.addObject(i)
		end
	end
	
end

function kAlert.config.movers.addObject(id)

	local iID = tostring(id)
	local object = UI.CreateFrame("Frame", "objectMoverFrame" .. iID, kAlert.context)
	object:SetWidth(75)
	object:SetHeight(75)
	object:SetPoint ("TOPLEFT", kAlert.context, "TOPLEFT")
	object:SetVisible(false)
	object:SetBackgroundColor(0, 0, 0, 0.5)
	object.movable = true
	object.target = nil
	
	function object.clearTarget()
		object.target = nil
		object:SetVisible(false)
	end
	
	function object.setTarget(target)
		object.movable = true
		object.target = target
		object:SetVisible(true)
		object:SetWidth(target:GetWidth())
		object:SetHeight(target:GetHeight())
		object:SetPoint("TOPLEFT", target, "TOPLEFT")
	end
	
	function object.Event:LeftDown()
		self.MouseDown = self.movable
		mouseData = Inspect.Mouse()
		self.MyStartX = self:GetLeft()
		self.MyStartY = self:GetTop()
		self.StartX = mouseData.x - self.MyStartX
		self.StartY = mouseData.y - self.MyStartY
	end
	
	function object.Event:MouseMove(mouseX, mouseY)
		if self.MouseDown then
			self:SetPoint("TOPLEFT", UIParent, "TOPLEFT", math.floor(mouseX - self.StartX), math.floor(mouseY - self.StartY))
			if object.target ~= nil then
				object.target:SetPoint("TOPLEFT", UIParent, "TOPLEFT", math.floor(mouseX - self.StartX), math.floor(mouseY - self.StartY))
			end
		end
	end
	
	function object.Event:LeftUp()
		self.MouseDown = false
	end
	
	return object
	
end
