local info, data = ...
local me = {Name = "myUI Combo Points", Addon = info.identifier, SettingsKey = "ComboTracker", ModuleVersion = "0.2.0", ReleaseType = "(public beta)"};
table.insert(Event.Addon.Load.End, {function(addon) if (addon == me.Addon) then myUI:RegisterModule(me)  end end, me.Addon, "_startup"})

local L
local ComboTracker = me
myUI.ComboTracker = me

local __onComboPoints, __onTargetChanged, __onUnitDetal

function ComboTracker:GetDefaults()
	local defaults = {
		FirstRun = true,
		Enabled = true,
		Version = self.ModuleVersion,
		x = 0,
		y = 0,
		cx = 240,
		spacing = 4,
		curve = 0,
		anchor = "CENTER"
	}
	return defaults
end

function ComboTracker:Initialize(profile)
	myUI.ComboTracker = self
	self.isnil = myUI.global.isnil
	self.ifnil = myUI.global.ifnil

	L = self:LoadLanguage()
	
	local def = profile.ComboTracker
	
	profile.Version = self.ModuleVersion -- nothing from older version so update right now so just set 
	if (nil == def.anchor) then  -- reset for pre-0.1.3 verions
		def.anchor = "CENTER" 
		def.x = 0
		def.y = 0
	end
	
	self.Definition = def
	self.isRogue = nil
	self.isWarrior = nil
	
	self.Bg = myUI:CreateFrame("Frame")
	self.Bg:SetVisible(false)
	self.Bg:SetLayer(0)
	
	--self.Curver = myUI:CreateFrame("Frame", self.Bg);
	--self.Curver:SetLayer(1)
	
	self.Bg:SetBackgroundColor(0.6,0,0,0.5)
	--self.Curver:SetBackgroundColor(0.6,0,0,0.5)
	
	self:Layout();

	--[[
	
	self.Bg.dragging = false;
	self.Bg.offx = 0;
	self.Bg.offy = 0;
	self.Bg.lastx = 0;
	self.Bg.lasty = 0;
	
	
	self.Bg.Event.LeftDown = function(bg)
	
		bg.dragging = true;
		
		local m = Inspect.Mouse()
		bg.lastx = m.x
		bg.lasty = m.y
		bg.offx = m.x - bg:GetLeft() 
		bg.offy = m.y - bg:GetTop()			
	end
	
	local fn = function(bg)
		bg.dragging = false;
		
		myUI.ComboTracker.Definition.x = bg:GetLeft();
		myUI.ComboTracker.Definition.y = bg:GetTop();
		myUI.ComboTracker.Definition.anchor = "TOPLEFT"
		myUI.ComboTracker:Layout();		
	end
	self.Bg.Event.LeftUp = fn
	self.Bg.Event.LeftUpoutside = fn

	self.Bg.Event.MouseMove = function(bg, x, y)
		if (bg.dragging) then
			local m = Inspect.Mouse()
			
			if (math.abs(m.x - bg.lastx) > 1) or (math.abs(m.y - bg.lasty) > 1) then				
				local x = m.x - bg.offx
				local y = m.y - bg.offy
				myUI.ComboTracker.Definition.anchor = "TOPLEFT"
				bg:ClearAll()
				bg:SetPoint("TOPLEFT", UIParent, "TOPLEFT", x, y);
		
				bg.lastx = m.x
				bg.lasty = m.y
			end
		end
	end

	
	
	self.Curver.Event.WheelForward = function(cv)
		local curve = ComboTracker.Definition.curve
		curve = curve - 1
		
		if (curve > -8) then
			ComboTracker.Definition.curve = curve
			ComboTracker:Layout()
		end
	end
	
	self.Curver.Event.WheelBack = function(cv)
		local curve = ComboTracker.Definition.curve
		curve = curve + 1
		
		if (curve < 8) then
			ComboTracker.Definition.curve = curve
			ComboTracker:Layout()
		end
	end
	
	self.Bg.Event.WheelForward = function(bg)
		local cx = ComboTracker.Definition.cx
		
		cx = cx + 2
		if (cx < 800) then
			ComboTracker.Definition.cx = cx
			ComboTracker:Layout();
		end
	end
	
	self.Bg.Event.WheelBack = function(bg)
		local cx = ComboTracker.Definition.cx
		
		cx = cx - 2
		if (cx > 120) then
			ComboTracker.Definition.cx = cx
			ComboTracker:Layout();
		end
	end

	]]--
	
	table.insert(Event.Unit.Available, {__onUnitDetail, "myUICP", "ctOnUnitDetail"});
	
end

__onUnitDetail = function(units)
	if (ComboTracker.Definition.Enabled) then
		if (me.isnil(myUI.ComboTracker.isRogue)) then
			local detail = Inspect.Unit.Detail("player")
			if (detail) and (detail.calling) then
				myUI.ComboTracker.isRogue = (detail.calling == "rogue")
				
				if (myUI.ComboTracker.isRogue) then
					table.insert(Event.Unit.Detail.Combo, {__onComboPoints, "myUICP", "ctOnComboPoints"});
					table.insert(Event.Unit.Detail.ComboUnit, {__onComboPoints, "myUICP", "ctOnComboPoints"});
					
					table.insert(Event.Unit.Add, {__onTargetChanged, "myUICP", "ctOnTargetChanged"});
					table.insert(Event.Unit.Remove, {__onTargetChanged, "myUICP", "ctOnTargetChanged"});
					table.insert(Event.Unit.Unavailable, {__onTargetChanged, "myUICP", "ctOnTargetChanged"});
					
					local texs = myUI.ComboTracker.Bg.Textures
					texs[1]:SetVisible(true)
					texs[5]:SetVisible(true)
					texs[9]:SetVisible(true)
					texs[13]:SetVisible(true)
					texs[16]:SetVisible(true)
				end
			end
		end
		if (me.isnil(myUI.ComboTracker.isWarrior)) then
			local detail = Inspect.Unit.Detail("player")
			if (detail) and (detail.calling) then
				myUI.ComboTracker.isWarrior = (detail.calling == "warrior")
				
				if (myUI.ComboTracker.isWarrior) then
					table.insert(Event.Unit.Detail.Combo, {__onComboPoints, "myUICP", "ctOnComboPoints"});
					table.insert(Event.Unit.Detail.ComboUnit, {__onComboPoints, "myUICP", "ctOnComboPoints"});
					
					local texs = myUI.ComboTracker.Bg.Textures
					texs[1]:SetVisible(false)
					texs[5]:SetVisible(true)
					texs[9]:SetVisible(true)
					texs[13]:SetVisible(true)
					texs[16]:SetVisible(false)
				end
		
			end
		end
		
		if (myUI.ComboTracker.isRogue) then
			__onTargetChanged(units)
		end
	else
		local texs = ComboTracker.Bg.Textures
		if (texs) then
			for _, t in ipairs(texs) do t:SetVisible(false) end
		end
	end
end

__onTargetChanged = function(units)
	local tid = Inspect.Unit.Lookup("player.target")
	
	if (tid ~= ComboTracker._lastTarget) then
		ComboTracker._lastTarget = tid			
		__onComboPoints(units)		
	end
end

__onComboPoints = function(units)	
	
	local texs = ComboTracker.Bg.Textures
	if (not texs) then return end
	
	if (ComboTracker.Definition.Enabled) then
		local state = {};
		local detail = Inspect.Unit.Detail("player")
	
		
		local rogue = ComboTracker.isRogue
		local war = ComboTracker.isWarrior
		
		if (detail) and ((detail.comboUnit == ComboTracker._lastTarget) or ComboTracker.isWarrior) then
			local cps = detail.combo
			
			ComboTracker._lastTarget = detail.comboUnit
			
			if (rogue) then		
				if (me.isnil(cps) or (cps == 0)) then
					state[1] = true
					state[5] = true
					state[9] = true
					state[13] = true
					state[16] = true
				elseif (cps == 1) then
					state[2] = true
					state[5] = true
					state[9] = true
					state[13] = true
					state[16] = true
				elseif (cps == 2) then
					state[2] = true
					state[6] = true
					state[9] = true
					state[13] = true
					state[16] = true
				elseif (cps == 3) then
					state[2] = true
					state[6] = true
					state[10] = true
					state[13] = true
					state[16] = true
				elseif (cps == 4) then
					state[3] = true
					state[7] = true
					state[11] = true
					state[14] = true
					state[16] = true
				elseif (cps == 5) then
					state[4] = true
					state[8] = true
					state[12] = true
					state[15] = true
					state[17] = true
				end
			elseif war then
				if (me.isnil(cps) or (cps == 0)) then
					state[5] = true
					state[9] = true
					state[13] = true
				elseif (cps == 1) then
					state[6] = true
					state[9] = true
					state[13] = true
				elseif (cps == 2) then				
					state[7] = true
					state[11] = true
					state[13] = true
				elseif (cps == 3) then
					state[8] = true
					state[12] = true
					state[15] = true
				end
			end
		else
			state[1] = rogue --true
			state[5] = true
			state[9] = true
			state[13] = true
			state[16] = rogue --true
		end
	
		for i=1, #texs, 1 do
			texs[i]:SetVisible(me.ifnil(state[i], false, true));
		end	
	else
		for i = 1, #texs, 1 do
			texs[i]:SetVisible(false)
		end
	end
	

end

function ComboTracker:Layout()
	local def = self.Definition
	
	self.Bg:ClearAll()
	self.Bg:SetPoint(def.anchor, UIParent, def.anchor, def.x, def.y)
	
	local cx = self.Definition.cx
	local cy = self.Definition.cy
	local spacing = self.Definition.spacing
	
	self.Bg:SetWidth(cx)
	self.Bg:SetHeight(cx/5)
	
	local cxytex = (cx - (4 * spacing))/5
	
	--self.Curver:SetWidth(cx/5)
	--self.Curver:SetHeight(cx/5)
	--self.Curver:SetPoint("CENTER", self.Bg, "CENTER")
	
	local textures
	
	if (self.Bg.Textures == nil) then
		textures = {}
		
		for i=1, 17, 1 do
			table.insert(textures, myUI:CreateFrame("Texture"))
		end
		
		-- combo 1
		textures[1]:SetTexture("myUI","images/combo0.png");
		textures[2]:SetTexture("myUI","images/combo1.png");
		textures[3]:SetTexture("myUI","images/combo2.png");
		textures[4]:SetTexture("myUI","images/combo3.png");	
		-- combo 2
		textures[5]:SetTexture("myUI","images/combo0.png");
		textures[6]:SetTexture("myUI","images/combo1.png");
		textures[7]:SetTexture("myUI","images/combo2.png");
		textures[8]:SetTexture("myUI","images/combo3.png");	
		-- combo 3
		textures[9]:SetTexture("myUI","images/combo0.png");
		textures[10]:SetTexture("myUI","images/combo1.png");
		textures[11]:SetTexture("myUI","images/combo2.png");
		textures[12]:SetTexture("myUI","images/combo3.png");	
		-- combo 4
		textures[13]:SetTexture("myUI","images/combo0.png");
		textures[14]:SetTexture("myUI","images/combo2.png");
		textures[15]:SetTexture("myUI","images/combo3.png");
		-- combo 5
		textures[16]:SetTexture("myUI","images/combo0.png");
		textures[17]:SetTexture("myUI","images/combo3.png");
		
		for i = 1,#textures,1 do
			textures[i]:SetVisible(false)
		end
		
		self.Bg.Textures = textures
	end
	
	textures = self.Bg.Textures
	
	for i=1, 17, 1 do
		textures[i]:SetWidth(cxytex)
		textures[i]:SetHeight(cxytex)
		textures[i]:SetLayer(10)
	end
		
	cx = 0; 
	cy = (spacing / 4) * self.Definition.curve
	for i=1, 4, 1 do
		textures[i]:SetPoint("TOPLEFT", self.Bg, "TOPLEFT", cx, cy*(3^1.5) + spacing);
	end
	
	cx = cx + spacing + cxytex	
	for i=5, 8, 1 do
		textures[i]:SetPoint("TOPLEFT", self.Bg, "TOPLEFT", cx, cy + spacing);
	end
		
	cx = cx + spacing + cxytex
	for i=9, 12, 1 do
		textures[i]:SetPoint("TOPLEFT", self.Bg, "TOPLEFT", cx, spacing);
	end
	
	cx = cx + spacing + cxytex
	for i=13,15,1 do
		textures[i]:SetPoint("TOPLEFT", self.Bg, "TOPLEFT", cx, cy + spacing);
	end
	
	cx = cx + spacing + cxytex
	for i=16,17,1 do
		textures[i]:SetPoint("TOPLEFT", self.Bg, "TOPLEFT", cx, cy*(3^1.5) + spacing);
	end
	
end

function ComboTracker:ToggleMovers()
	self.Bg:SetVisible(not self.Bg:GetVisible());

end
function ComboTracker:ShowMovers()
	self.Bg:SetVisible(true)
end
function ComboTracker:HideMovers()
	self.Bg:SetVisible(false)
end

function ComboTracker:SetEnabled(enabled)
	if (nil == enabled) then enabled = not self.Definition.Enabled end
	self.Definition.Enabled = enabled
	__onComboPoints(nil)
end

local _configFrame = nil

function ComboTracker:GetConfigFrame(parent)
	if (not _configFrame) then
		_configFrame = myUI:CreateFrame("Frame", parent)
	
		local border = 16
		local white = myUI.colors.White
		local black = myUI.colors.Black
		local f
		local minmax = myUI.global.minmax
		
		f = myUI:CreateFrame("RiftCheckbox", _configFrame)
		f:SetLayer(parent:GetLayer() + 1)
		f:SetPoint("TOPLEFT", _configFrame, "TOPLEFT", border, border)		
		f:SetChecked(self.Definition.Enabled)
		f.Event.CheckboxChange = function(chk)
			ComboTracker:SetEnabled()
		end
		_configFrame.chkEnabled = f
		
		f = myUI:CreateFrame("Text", _configFrame.chkEnabled)
		f:Autosize(L["Enabled"])
		f:SetPoint("LEFTCENTER", _configFrame.chkEnabled, "RIGHTCENTER", 4, 0)
		_configFrame.txtEnabled  = f
		
		local cxscreen = UIParent:GetWidth()
		local cyscreen = UIParent:GetHeight()
		
		f = myUI.Widgets.AnchorBox:new(_configFrame)
		f:SetPoint("TOPLEFT", _configFrame.chkEnabled, "BOTTOMLEFT", 180, border * 3)
		f:SetWidth(200)
		f:SetHeight(200 * cyscreen/ cxscreen)
		f:SetAnchor(ComboTracker.Definition.anchor)
		f.AnchorChanged = function(self, anchor)
			ComboTracker.Definition.anchor = anchor
			ComboTracker:Layout()
		end
		
		_configFrame.ScreenBox = f		
		_configFrame.anchorChecks = anchors
		
		f = myUI:CreateFrame("Text", _configFrame)
		f:Autosize(L["Anchor"])
		f:SetPoint("TOPRIGHT", _configFrame.ScreenBox, "TOPLEFT", -border,  0)
		_configFrame.txtAnchor = f
		
		f = myUI:CreateFrame("Text", _configFrame)
		f:Autosize(L["X-Offset:"])
		f:SetPoint("TOPRIGHT", _configFrame.ScreenBox, "BOTTOMLEFT", -border, border)
		_configFrame.lblX = f
		
		f = myUI:CreateFrame("Text", _configFrame)
		f:Autosize(L["Y-Offset:"])
		f:SetPoint("TOPRIGHT", _configFrame.lblX, "BOTTOMRIGHT", 0, 4)
		_configFrame.lblY = f
		
		f = myUI:CreateFrame("Text", _configFrame)
		f:Autosize(L["Size:"])
		f:SetPoint("TOPRIGHT", _configFrame.lblY, "BOTTOMRIGHT", 0, 4)
		_configFrame.lblCX = f
		
		f = myUI:CreateFrame("Text", _configFrame)
		f:Autosize(L["Arch:"])
		f:SetPoint("TOPRIGHT", _configFrame.lblCX, "BOTTOMRIGHT", 0, 4)
		_configFrame.lblArch = f
		
		local activebg = myUI.color:clone(black, 100)
		
		f = myUI:CreateFrame("RiftTextfield", _configFrame)
		f:SetText(tostring(math.floor(ComboTracker.Definition.x)))
		f:SetWidth(60)
		f:SetBackgroundColor(activebg:rgba())
		f:SetPoint("LEFTCENTER", _configFrame.lblX, "RIGHTCENTER", border, 0)
		_configFrame.txtX = f
		
		f = myUI:CreateFrame("RiftTextfield", _configFrame)
		f:SetText(tostring(math.floor(ComboTracker.Definition.y)))
		f:SetWidth(60)
		f:SetBackgroundColor(activebg:rgba())
		f:SetPoint("LEFTCENTER", _configFrame.lblY, "RIGHTCENTER", border, 0)
		_configFrame.txtY = f
		
		f = myUI:CreateFrame("RiftTextfield", _configFrame)
		f:SetText(tostring(math.floor(ComboTracker.Definition.cx)))
		f:SetWidth(60)
		f:SetBackgroundColor(activebg:rgba())
		f:SetPoint("LEFTCENTER", _configFrame.lblCX, "RIGHTCENTER", border, 0)
		_configFrame.txtCX = f
		
		f = myUI:CreateFrame("RiftTextfield", _configFrame)
		f:SetText(tostring(math.floor(ComboTracker.Definition.curve)))
		f:SetWidth(60)
		f:SetBackgroundColor(activebg:rgba())
		f:SetPoint("LEFTCENTER", _configFrame.lblArch, "RIGHTCENTER", border, 0)
		_configFrame.txtArch = f
		
		f = myUI:CreateFrame("Text", _configFrame)
		f.max = math.floor(cxscreen/2)
		f.min = -f.max
		f:Autosize("(" .. tostring(f.min) .. " <-> " .. tostring(f.max) .. ")")
		f:SetPoint("LEFTCENTER", _configFrame.txtX, "RIGHTCENTER", border, 0)
		_configFrame.lblX2 = f
		
		f = myUI:CreateFrame("Text", _configFrame)
		f.max = math.floor(cyscreen/2)
		f.min = -f.max
		f:Autosize("(" .. tostring(f.min) .. " <-> " .. tostring(f.max) .. ")")
		f:SetPoint("LEFTCENTER", _configFrame.txtY, "RIGHTCENTER", border, 0)
		_configFrame.lblY2 = f
		
		f = myUI:CreateFrame("Text", _configFrame)
		f.max = 800
		f.min = 120
		f:Autosize("(" .. tostring(f.min) .. " <-> " .. tostring(f.max) .. ")")
		f:SetPoint("LEFTCENTER", _configFrame.txtCX, "RIGHTCENTER", border, 0)
		_configFrame.lblCX2 = f
		
		f = myUI:CreateFrame("Text", _configFrame)
		f.max = 8
		f.min = -8
		f:Autosize("(" .. tostring(f.min) .. " <-> " .. tostring(f.max) .. ")")
		f:SetPoint("LEFTCENTER", _configFrame.txtArch, "RIGHTCENTER", border, 0)
		_configFrame.lblArch2 = f
		
		f = myUI:CreateFrame("RiftButton", _configFrame)
		f:SetText(L["Apply"])
		f:SetPoint("TOPLEFT", _configFrame.txtArch, "BOTTOMLEFT", 0, 8)
		f.Event.LeftClick = function(btn)
			local x, y, cx, a
			
			if (pcall(function()
					x = 0+tonumber(_configFrame.txtX:GetText())
					y = 0+tonumber(_configFrame.txtY:GetText())
					cx = 0+tonumber(_configFrame.txtCX:GetText())
					a = 0+tonumber(_configFrame.txtArch:GetText())
				end)) then
				
				if (x < _configFrame.lblX2.min) or (x > _configFrame.lblX2.max) then
					myUI:msgbox(_configFrame, L["Bad X"], _, "OK", "WARNING")
					return
				end
				if (y < _configFrame.lblY2.min) or (y > _configFrame.lblY2.max) then
					myUI:msgbox(_configFrame, L["Bad Y"], _, "OK", "WARNING")
					return
				end
				if (cx < _configFrame.lblCX2.min) or (cx > _configFrame.lblCX2.max) then
					myUI:msgbox(_configFrame, L["Bad CX"], _, "OK", "WARNING")
					return 
				end
				if (a < _configFrame.lblArch2.min) or (a > _configFrame.lblArch2.max) then
					myUI:msgbox(_configFrame, L["Bad Arch"], _, "OK", "WARNING")
					return
				end
				
				local def = ComboTracker.Definition
				def.x = x
				def.y = y
				def.cx = cx
				def.curve = a
			
				ComboTracker:Layout()
			else
				myUI:msgbox(_configFrame, L["Invalid value"], _, "OK", "WARNING")
			end
		
		
		
		end
		_configFrame.btnApply = f
	end
	
	return _configFrame
end




